﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Drawing;

namespace CG1.Ex08.Rasterization
{
   class Line
    {
        public void RasterizeLineBresenham(Bitmap Image, int x0, int y0, int x1, int y1)
        {
            // Choose which oktant - first X or second Y
            if (Math.Abs(x1 - x0) > Math.Abs(y1 - y0))
                RasterizeLineBresenhamX(Image, x0, y0, x1, y1);
            else
                RasterizeLineBresenhamY(Image, x0, y0, x1, y1);
        }

        protected void RasterizeLineBresenhamX(Bitmap Image, int x0, int y0, int x1, int y1)
        {
            int dx = x1 - x0;
            int dy = y1 - y0;
            int sx = (dx > 0) ? 1 : -1;
            int sy = (dy > 0) ? 1 : -1;
            dx = Math.Abs(dx);
            dy = Math.Abs(dy);

            //Podmienky z prednasky
            int c1 = 2 * dy;
            int c2 = 2 * (dy - dx);
            int p = c1 - dx;

            SetPixel(Image, x0, y0);
            while (x0 != x1)
            {
                x0 += sx;
                if (p < 0)
                {
                    p += c1;
                }
                else
                {
                    p += c2;
                    y0 += sy;
                }
                SetPixel(Image, x0, y0);
            }
        }

        protected void RasterizeLineBresenhamY(Bitmap Image, int x0, int y0, int x1, int y1)
        {
            int dx = x1 - x0;
            int dy = y1 - y0;
            int sx = (dx > 0) ? 1 : -1;
            int sy = (dy > 0) ? 1 : -1;
            dx = Math.Abs(dx);
            dy = Math.Abs(dy);

            int c1 = 2 * dx;
            int c2 = 2 * (dx - dy);
            int p = c1 - dy;

            SetPixel(Image, x0, y0);
            while (y0 != y1)
            {
                y0 += sy;
                if (p < 0)
                {
                    p += c1;
                }
                else
                {
                    p += c2;
                    x0 += sx;
                }
                SetPixel(Image, x0, y0);
            }
        }

        protected void SetPixel(Bitmap g, int x, int y)
        {
            g.SetPixel(x, y, Color.Black);
        }
    }
}
